from client import get_client, DEFAULT_ORGANIZATION
from time import sleep

API_KEY = "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"

def main():
    client = get_client(API_KEY, DEFAULT_ORGANIZATION)
    thread = client.beta.threads.create()
    assistant_id = ""

    with open("assistant_id", 'r') as f:
        assistant_id = f.readline()

    running = True
    while running:
        try:
            user_message = input("Your message: ")
            message = client.beta.threads.messages.create(
                thread_id=thread.id,
                role="user",
                content=user_message,
            )

            run = client.beta.threads.runs.create(
                thread.id,
                assistant_id=assistant_id,
            )

            # streaming currently not supported
            while run.status != "completed": # a lot more states must be checked in production
                run = client.beta.threads.runs.retrieve(
                    thread_id=thread.id,
                    run_id=run.id,
                )
                sleep(2)

            responses = client.beta.threads.messages.list(
                thread.id,
            )

            responses_to_message = [r for r in responses.data if r.run_id == run.id and r.role == "assistant"]

            for response in responses_to_message:
                for response_content in response.content:
                    # not really safe like this, type should be checked
                    print(response_content.text.value)

        except (KeyboardInterrupt):
            running = False

    client.beta.threads.delete(thread.id)


if  __name__ == "__main__":
    main()
